<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<!--
vim:tw=78
-->
<html lang="en">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
        <title>EtherLab :: Rexroth HDx Direct Valve</title>
        <link rel="stylesheet" href="docstyle.css" type="text/css">
        <meta name="generator" content="DocBook XSL Stylesheets V1.52.2">
        <meta http-equiv="Content-Script-Type" content="text/javascript">
        <meta name="toctype" content="ug">
        <script language="JavaScript" src="docscripts.js"></script>
    </head>
    <body>
        <a name="top_of_page"></a>
        <p style="font-size:1px;">&nbsp;</p>
        <h1>Rexroth HDB and HDE-based Valves</h1>

        <p>This block supports Valves from Bosch Rexroth running the CiA 408
        Fluid Power profile.
        Per default, the block has two Inputs and two Outputs,
        which are the CiA408 Control Word/Status Word and the
        Target Spool Position resp. Current Spool Position.
        </p>

        <p>Up to three Analog Inputs can be configured and mapped
        to an Output port.
        Please note that for HDB devices, the Input type (Current or Voltage)
        of Inputs one and two must be identical.
        For Voltage, the unit of the Outputs is Volt (V), for Current the unit is
        Milliampere (mA).
        </p>

        <p>See <a href="general.html">General Options</a> for a description of
        the mask fields.
        </p>

        <h2>Connecting IndraWorks via Ethernet over EtherCAT (EoE)</h2>

        <p>IndraWorks Ds is the commissioning tool provided by Rexroth.
        In the following, it is assumed that the valve is connected to an
        EtherCAT master at position zero.
        </p>

        <p><b>NOTE:</b> If the Valve is in Error state (<code>PREOP+E</code>),
        communication via EoE is not possible.
        Switch the Valve to <code>PREOP</code> state manually with the EtherCAT
        tool using <code>ethercat states -p 0 preop</code>.</p>

        <a name="prepare"><h3>Prepare the Valve</h3></a>

        <p>First step is to bring up the EoE network device on the Host of the
        EtherCAT master, <code>eoe0s0</code>:
        <code>sudo ip link set dev eoe0s0 up</code>.
        After that, an ip address is assigned to the Valve using the
        <code>ethercat</code> tool:
        <code>sudo ethercat ip -p 0 ip_address 192.168.0.1/24</code>
        </p>
        <h3>Option 1: Create a network bridge</h3>

        <p>This section explains how to forward all EoE traffic
        to a spare network port of the EtherCAT master
        or an EL6601 Switchport.
        This spare network card has the name <code>eth1</code>.
        A second machine running IndraWorks Ds will be attached to this port,
        which has the IP address <code>192.168.0.199/24</code>.
        </p>

        <pre>
        sudo ip link add dev br0 type bridge
        sudo ip link set dev br0 up
        sudo ip link set dev eoe0s0 master br0
        sudo ip link set dev eth1 up
        sudo ip link set dev eth1 master br0
        # disable packet filtering for bridges
        sudo sysctl -w net.bridge.bridge-nf-call-iptables=0
        </pre>

        <h3>Option 2: Using an SSH tunnel with Port Forwarding</h3>

        <p>Without local access to the EtherCAT Master,
        a SSH tunnel allows accessing the Valve from remote without complex
        routing setup. The port <b>35021</b> needs to be
        forwarded from a machine in the same subnet as the IndraWorks machine.
        </p>

        <p>The EoE device on the host <code>eoe0s0</code> will be given
        an IP address in the same range as the Valve itself.
        <pre>
            sudo ip address add dev eoe0s0 192.168.0.10/24
        </pre>
        Pinging the Valve should now be possible.
        </p>

        <p>It is assumed that the machine which provides the ssh tunnel
        has the IP address 192.168.101.10.
        Open an SSH tunnel to the host which
        runs the EtherCAT master (ethercatctl):
        <pre>
            ssh -L 192.168.101.10:35021:192.168.0.1:35021 ethercatctl
        </pre>
        The port 35021 needs to be reachable from the same subnet.
        Then, point IndraWorks Ds to <code>192.168.101.10</code> in the connection dialog.
        </p>

    <h2>Initial Commissioning</h2>
    <p>For using this EtherLab block, the Valve must be configured to use
    the <code>Fluid Power</code> Profile.
    Master Communication is expected to be <code>CAN Application Protocol over
    EtherCAT (CoE)</code>.
    </p>

    <h3>Open Loop Functional Package</h3>

    <p>Navigate to <q>Functional Packages</q> and activate <q>Open-loop</q>
    Functional Package. Reboot the valve afterwards. After the reboot,
    the EoE settings explained <a href="#prepare">above</a> must be redone
    to restore the connection to IndraWorks.
    </p>

    <img src="rexroth_functionalpackage.png"/>

    <h3>Fluid Power Profile</h3>

    <p>Navigate to <q>Settings</q> below <q>Master communication axis</q>.
    Choose <q>Axis remains in PM (parameter mode)</q> in the combo box at the bottom.
    Select <code>Fluid Power Profile</code>,
    then click on <q>Activate Profile type</q> and reboot the valve again.
    After the reboot, restore the <a href="#prepare">EoE Settings</a>.
    </p>

    <p>
    <img src="rexroth_fluidpower.png"/>
    <div class="caption">The master communication axis settings after reboot.</div>
    </p>

    <h3>Direct Valve control</h3>
    <p>Navigate to <q>Operation mode selection</q> below <q>Operation modes</q>.
    Select <code>Direct valve control</code> as primary operation mode.</p>

    <img src="rexroth_operationmode.png"/>

    <h3>Parameter Storage mode</h3>

    <p>Per default, parameters are written to the flash storage on every write.
    All further parameters are stored in the EtherLab blocks and will be written
    on every application startup.
    To protect the flash storage, navigate to the menu item <q>Parameterization</q> &#8594;
    <q>Parameters</q> &#8594; <q>Storage mode</q>.
    Select <code>Backup parameters in working memory (RAM) only</code> and press
    <q>Backup working memory procedure</q>.
    </p>

    <img src="rexroth_storagemode.png"/>

    </body>
</html>
